#include "GLRGBColour.h"
#include <cmath>

GLRGBColour operator*(const GLRGBColour& x, const GLfloat& s)
{
   GLRGBColour ans(x.r * s, x.g * s, x.b * s);
   return ans;
}

GLRGBColour operator*(const GLRGBColour& x, const GLRGBColour& y)
{
   GLRGBColour ans(x.r * y.r, x.g * y.g, x.b * y.b);
   return ans;
}

void operator+=(GLRGBColour& x, const GLRGBColour& y)
{
   x.r += y.r;
   x.g += y.g;
   x.b += y.b;
}

void operator/=(GLRGBColour& x, const GLfloat& s)
{
   x.r /= s;
   x.g /= s;
   x.b /= s;
}

void GLRGBColour::set_black()
{
   r = 0.0f;
   g = 0.0f;
   b = 0.0f;
}

void GLRGBColour::tone_map(const GLfloat& tone_mapping_factor)
{
   r = 1.0f - exp(-tone_mapping_factor * r);
   g = 1.0f - exp(-tone_mapping_factor * g);
   b = 1.0f - exp(-tone_mapping_factor * b);
}