#pragma once
#include "GL/glut.h"

class GLRGBColour
{
public:
   GLfloat r, g, b;

   GLRGBColour(const GLfloat r = 0.0f, const GLfloat g = 0.0f, const GLfloat b = 0.0f) : r(r), g(g), b(b) { };
   void tone_map(const GLfloat& tone_mapping_factor);
   void set_black();
};

GLRGBColour operator*(const GLRGBColour& x, const GLfloat& s);
GLRGBColour operator*(const GLRGBColour& x, const GLRGBColour& y);
void operator+=(GLRGBColour& x, const GLRGBColour& y);
void operator/=(GLRGBColour& x, const GLfloat& s);

const GLRGBColour Black(0.0f, 0.0f, 0.0f);
const GLRGBColour White(1.0f, 1.0f, 1.0f);
const GLRGBColour Red(1.0f, 0.0f, 0.0f);
const GLRGBColour Green(0.0f, 1.0f, 0.0f);
const GLRGBColour Blue(0.0f, 0.0f, 1.0f);
const GLRGBColour Yellow(1.0f, 1.0f, 0.0f);
const GLRGBColour Cyan(1.0f, 1.0f, 0.0f);
const GLRGBColour Magenta(0.0f, 1.0f, 1.0f);