#pragma once
#include <GL/glut.h>

class GLpoint3f
{
public:
   GLfloat x, y, z;

   GLpoint3f(const GLfloat x = 0.0f, const GLfloat y = 0.0f, const GLfloat z = 0.0f) : x(x), y(y), z(z) { };
   GLpoint3f cross(const GLpoint3f& p) const;
   GLfloat length2();
   GLfloat length();
   void normalise();
};

GLfloat get_area(const GLpoint3f& v1, const GLpoint3f& v2, const GLpoint3f& v3);
GLpoint3f operator-(const GLpoint3f& p1, const GLpoint3f& p2);
GLpoint3f operator+(const GLpoint3f& p1, const GLpoint3f& p2);
GLpoint3f operator*(const GLpoint3f& p, const GLfloat& s);
void operator*=(GLpoint3f& p, const GLfloat& s);