#include "HashTable.h"

HashTable::HashTable(const unsigned int& size) : size(size)
{
   data = new std::list<HashEntry>[size];
}

unsigned int HashTable::hash(const unsigned int& key1, const unsigned int& key2)
{ // I got this hash function from Nicholas who got it from the internet. I don't really know if it's any good but I hope so!
   __int64 key = (((__int64) key1) << 32) | (_int64) key2;
   
   key += ~(key << 32);
	key ^= (key >> 22);
	key += ~(key << 13);
	key ^= (key >> 8);
	key += (key << 3);
	key ^= (key >> 15);
	key += ~(key << 27);
	key ^= (key >> 31);
	return (unsigned int) (key % size);
}

void HashTable::add(const unsigned int& key1, const unsigned int& key2, const unsigned int& value)
{
   data[hash(key1, key2)].push_front(HashEntry(key1, key2, value));
   return;
}

bool HashTable::look_up(const unsigned int& key1, const unsigned int& key2, unsigned int& value)
{
   using namespace std;

   unsigned int index = hash(key1, key2);
   list<HashEntry>::iterator it;

   for(it = data[index].begin(); it != data[index].end(); it++)
   {
      if(it->key1 == key1 && it->key2 == key2)
      {
         value = it->value;
         return true;
      }
   }
   return false;
}

HashTable::~HashTable(void)
{
   delete [] data;
}