#pragma once
#include "Scene.h"
#include "GLpoint3f.h"

class Hemicube
{
public:
   unsigned int resolution;
   GLubyte *top, *bottom, *left, *right, *front;
   GLpoint3f centre, xAxis, yAxis, zAxis;
   Scene* scene;

   Hemicube(const unsigned int& resolution, const GLpoint3f& centre, const GLpoint3f& normal, Scene* scene);
   ~Hemicube(void);
   void rotate(const GLfloat& angle);
   void render_all(void);
   void render_face(const GLpoint3f& xAxis, const GLpoint3f& yAxis, const GLpoint3f& zAxis, GLubyte *image);
};
