#pragma once

#include "Mesh.h"
#include "GLpoint3f.h"
#include "GLRGBColour.h"
#include "3DS Loader/IScene.h"

class Hemicube;

class Scene : public IScene
{
public:
   static const unsigned int hemicube_resolution = 600; // hemicube_resolution should be divisible by 4 and no bigger than the window size OpenGL is rendering to.
   
   unsigned int n_meshes, n_patches;
   GLfloat hemicube_pixel_size;
   Mesh *meshes;

   Scene(void);
   ~Scene(void);
   void get_form_factors(const Hemicube& cube, GLfloat *form_factors);
   void run_pass(void);
   Mesh *addMesh(char *id, int vertCnt, int faceCnt); // Required because of IScene inheritance.
};