#include <fstream>
#include <cmath>

#include "misc.h"

bool is_prime(const unsigned int& n)
{ // Quick algorithm eh! It'll do.
   if(n == 1) return false;
   if(!(n % 2)) return false;
   unsigned int i, sqrt_n = (unsigned int) floor(sqrt((float) n));
   for(i = 3; i <= sqrt_n; i += 2)
   {
      if(!(n % i)) return false;
   }
   return true;
}

unsigned int next_prime(const unsigned int& n)
{
   if(n == 1 || n == 0) return 2;
   int i;
   for(i = (n % 2) ? n : n + 1; !is_prime(i); i += 2) ;
   return i;
}

void sPutDW(unsigned char *string, unsigned int n)
{
   string[0] = (unsigned char) (n & 0xFF);
   string[1] = (unsigned char) ((n & 0xFF00) >> 8);
   string[2] = (unsigned char) ((n & 0xFF0000) >> 16);
   string[3] = (unsigned char) ((n & 0xFF000000) >> 24);
   return;
}

void saveBMP24(char *fileName, GLubyte *image, int width, int height, bool vFlip)
{
   using namespace std;

   int bitmapHeaderLength = 54;
   unsigned char bitmapHeader[] = { // Header for 640x480x24bpp uncompressed BMP file.
        0x42, 0x4D, 0x36, 0xB4, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x04,
        0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x80, 0x02, 0x00, 0x00, 0xE0, 0x01,
        0x00, 0x00, 0x01, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB0,
        0x04, 0x00, 0xCE, 0x0E, 0x00, 0x00, 0xC4, 0x0E, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

   sPutDW(bitmapHeader + 2, bitmapHeaderLength + 3 * width * height);
   sPutDW(bitmapHeader + 10, bitmapHeaderLength);
   sPutDW(bitmapHeader + 18, width);
   sPutDW(bitmapHeader + 22, height);
   sPutDW(bitmapHeader + 34, 3 * width * height);
   ofstream outputFile(fileName, ios::out | ios::binary);
   outputFile.write((char *) bitmapHeader, bitmapHeaderLength);

   int x, y;
   if(vFlip == false)
   {
      for(y = height - 1; y >= 0; y--) // I should really add padding because BMP files like to have row lengths that are divisible by 4.
         for(x = 0; x < width; x++)
         {
            outputFile.put(image[(x + y * width) * 3 + 2]);
            outputFile.put(image[(x + y * width) * 3 + 1]);
            outputFile.put(image[(x + y * width) * 3]);
         }
   }
   else
   {
      for(y = 0; y < height; y++) // I should really add padding because BMP files like to have row lengths that are divisible by 4.
         for(x = 0; x < width; x++)
         {
            outputFile.put(image[(x + y * width) * 3 + 2]);
            outputFile.put(image[(x + y * width) * 3 + 1]);
            outputFile.put(image[(x + y * width) * 3]);
         }
   }
   outputFile.close();
   return;
}

float sqr(const float& x)
{
   return x * x;
}